;The TTP Project Boot Loader Version 1.0.3a
;Copyright 1998-2000 Michael Benoit and Leif Ames
org 0000h    ;org--nasm f**ks it up-need i say more??
jmp Start
;The GDT Register
gdtreg
        dw gdt_end+7c00h-gdt+7c00h-1
        dd gdt+7c00h
;The GDT -- Global Defunct Table
gdt
gdt0 
		dd 0
		dd 0
code_gdt
       
		dw 0ffffh
		dw 0h
		db 0h
		db 09ah 
		db 0cfh
		db 0h
data_gdt
       
		dw 0ffffh
		dw 0h
		db 0h
		db 092h
		db 0cfh
		db 0h
gdt_end

       
Start:
	mov ax,0x7c0
	mov ds,ax
;        call Set_Up_Stack
	call Read_TTP_Kernel
	cli             ;Only I can prevent interrupts!
        mov al,0x80     ;The same goes for NMI's
        out 0x70,al
        call build_GDT
        jmp enable_PM
Set_Up_Stack:
	cli		;A stack is a good thing
	mov ax,0x9000
	mov ss,ax
	mov sp,0h
	sti
	ret
Read_TTP_Kernel:
        mov ah,02h
        mov al,5h
        mov ch,0h
        mov cl,2h
        mov dh,0h
        mov dl,0h
        mov bx,100h
        mov es,bx
        mov bx,0h
        int 13
        ret

build_GDT:
        lgdt [gdtreg+7c00h]
        ret

        
enable_PM:

A20:            ;cli                     ;  Disable Interrupts
                call .isbuffempty       ;  Wait for Empty KB Buffer
                mov ax, 0xAD            ;  Disable Keyboard
                out 0x60, ax            ;  Disable Keyboard
                call .isbuffempty       ;  Wait for Empty KB Buffer
                mov ax, 0xD0            ;  Read Output Port
                out 0x60, ax            ;  Read Output Port
                call .isbuffempty       ;  Wait for Empty KB Buffer
                in ax, 0x60             ;  Save Output Port Data
                mov bx, ax              ;  Move Output Port Data into BX
                call .isbuffempty       ;  Wait for Empty KB Buffer
                mov ax, 0xD1            ;  Write Output Port
                out 0x60, ax            ;  Write Output Port
                call .isbuffempty       ;  Wait for Empty KB Buffer
                mov ax, bx              ;  Move Output Port Data into AX
                or ax, 0x02             ;  Set A20 Byte to On
                out 0x60, ax            ;  Send A20 On
                call .isbuffempty       ;  Wait for Empty KB Buffer
                mov ax, 0xAE            ;  Enable Keyboard
                out 0x60, ax            ;  Enable Keyboard
                ;sti                     ;  Enable Interrupts
                ;ret
                jmp done

.isbuffempty:   in ax, 0x64             ;  Get Status Register
                test ax, 0x02           ;  Test if KB Buffer is Empty
                loope .isbuffempty      ;  If Not, Wait Until it is
                ret

done:
	mov eax,cr0
	or al,1
	mov cr0,eax
	jmp $+2
        jmp 0x08:pmodeinto+7c00h    ;JMP to a FARaway place...
pmodeinto:
        mov ax,0001010b
        mov dx,3f2h
        ;out dx,ax       ;Turn on the floppy light!  No reason really...
        ;jmp 0x08:0x1000  ;Jump to ---DAS KERNEL!!
	mov [0xb8000], word 0x0403	;hehe
	jmp $ 		;Fine, I  Screwed up, just hang
	times 512-($-$$)-2 db 0
        dw 0xaa55
